# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.FirebaseRules.V1.Model.FunctionCall do
  @moduledoc """
  Represents a service-defined function call that was invoked during test execution.

  ## Attributes

  *   `args` (*type:* `list(any())`, *default:* `nil`) - The arguments that were provided to the function.
  *   `function` (*type:* `String.t`, *default:* `nil`) - Name of the function invoked.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :args => list(any()) | nil,
          :function => String.t() | nil
        }

  field(:args, type: :list)
  field(:function)
end

defimpl Poison.Decoder, for: GoogleApi.FirebaseRules.V1.Model.FunctionCall do
  def decode(value, options) do
    GoogleApi.FirebaseRules.V1.Model.FunctionCall.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.FirebaseRules.V1.Model.FunctionCall do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
