# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.FirebaseRules.V1.Model.ListReleasesResponse do
  @moduledoc """
  The response for FirebaseRulesService.ListReleases.

  ## Attributes

  *   `nextPageToken` (*type:* `String.t`, *default:* `nil`) - The pagination token to retrieve the next page of results. If the value is empty, no further results remain.
  *   `releases` (*type:* `list(GoogleApi.FirebaseRules.V1.Model.Release.t)`, *default:* `nil`) - List of `Release` instances.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :nextPageToken => String.t() | nil,
          :releases => list(GoogleApi.FirebaseRules.V1.Model.Release.t()) | nil
        }

  field(:nextPageToken)
  field(:releases, as: GoogleApi.FirebaseRules.V1.Model.Release, type: :list)
end

defimpl Poison.Decoder, for: GoogleApi.FirebaseRules.V1.Model.ListReleasesResponse do
  def decode(value, options) do
    GoogleApi.FirebaseRules.V1.Model.ListReleasesResponse.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.FirebaseRules.V1.Model.ListReleasesResponse do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
