# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.FirebaseRules.V1.Model.Result do
  @moduledoc """
  Possible result values from the function mock invocation.

  ## Attributes

  *   `undefined` (*type:* `GoogleApi.FirebaseRules.V1.Model.Empty.t`, *default:* `nil`) - The result is undefined, meaning the result could not be computed.
  *   `value` (*type:* `any()`, *default:* `nil`) - The result is an actual value. The type of the value must match that of the type declared by the service.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :undefined => GoogleApi.FirebaseRules.V1.Model.Empty.t() | nil,
          :value => any() | nil
        }

  field(:undefined, as: GoogleApi.FirebaseRules.V1.Model.Empty)
  field(:value)
end

defimpl Poison.Decoder, for: GoogleApi.FirebaseRules.V1.Model.Result do
  def decode(value, options) do
    GoogleApi.FirebaseRules.V1.Model.Result.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.FirebaseRules.V1.Model.Result do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
