# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.FirebaseRules.V1.Model.UpdateReleaseRequest do
  @moduledoc """
  The request for FirebaseRulesService.UpdateRelease.

  ## Attributes

  *   `release` (*type:* `GoogleApi.FirebaseRules.V1.Model.Release.t`, *default:* `nil`) - Required. `Release` to update.
  *   `updateMask` (*type:* `String.t`, *default:* `nil`) - Specifies which fields to update.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :release => GoogleApi.FirebaseRules.V1.Model.Release.t() | nil,
          :updateMask => String.t() | nil
        }

  field(:release, as: GoogleApi.FirebaseRules.V1.Model.Release)
  field(:updateMask)
end

defimpl Poison.Decoder, for: GoogleApi.FirebaseRules.V1.Model.UpdateReleaseRequest do
  def decode(value, options) do
    GoogleApi.FirebaseRules.V1.Model.UpdateReleaseRequest.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.FirebaseRules.V1.Model.UpdateReleaseRequest do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
