# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.FirebaseRules.V1.Model.ValueCount do
  @moduledoc """
  Tuple for how many times an Expression was evaluated to a particular ExpressionValue.

  ## Attributes

  *   `count` (*type:* `integer()`, *default:* `nil`) - The amount of times that expression returned.
  *   `value` (*type:* `any()`, *default:* `nil`) - The return value of the expression
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :count => integer() | nil,
          :value => any() | nil
        }

  field(:count)
  field(:value)
end

defimpl Poison.Decoder, for: GoogleApi.FirebaseRules.V1.Model.ValueCount do
  def decode(value, options) do
    GoogleApi.FirebaseRules.V1.Model.ValueCount.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.FirebaseRules.V1.Model.ValueCount do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
