# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.FirebaseRules.V1.Model.VisitedExpression do
  @moduledoc """
  Store the position and access outcome for an expression visited in rules.

  ## Attributes

  *   `sourcePosition` (*type:* `GoogleApi.FirebaseRules.V1.Model.SourcePosition.t`, *default:* `nil`) - Position in the `Source` or `Ruleset` where an expression was visited.
  *   `value` (*type:* `any()`, *default:* `nil`) - The evaluated value for the visited expression, e.g. true/false
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :sourcePosition => GoogleApi.FirebaseRules.V1.Model.SourcePosition.t() | nil,
          :value => any() | nil
        }

  field(:sourcePosition, as: GoogleApi.FirebaseRules.V1.Model.SourcePosition)
  field(:value)
end

defimpl Poison.Decoder, for: GoogleApi.FirebaseRules.V1.Model.VisitedExpression do
  def decode(value, options) do
    GoogleApi.FirebaseRules.V1.Model.VisitedExpression.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.FirebaseRules.V1.Model.VisitedExpression do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
